
package de.ivu.elect.presentation.dokumente.menu;

import java.util.Arrays;
import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.dokumente.control.DokumentKonverterLookup;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahl.boundary.WahlSessionSelector;
import de.ivu.elect.business.wahl.boundary.WahlterminSessionSelect;
import de.ivu.elect.presentation.dokumente.DokumentVorlageArchiveCreateView;
import de.ivu.elect.presentation.dokumente.DokumentVorlageCreateView;
import de.ivu.elect.presentation.dokumente.DokumentVorlageSearchView;

public class DokumentVorlageVerwaltenMenuItemEntry extends AbstractDokumentVorlageMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  private WahlSessionSelector wahlSelect;

  @Inject
  private WahlterminSessionSelect wahlterminSelect;

  @Inject
  private DokumentKonverterLookup dokumentKonverterLookup;

  public DokumentVorlageVerwaltenMenuItemEntry() {
    super();
  }

  @Override
  protected UseCasePermission getUseCasePermission() {
    return UseCasePermission.DOKUMENT_VORLAGE_SEARCH;
  }

  @Override
  public boolean isRendered() {
    return super.isRendered() && dokumentKonverterLookup.isDokumentKonverterVorhanden();
  }

  @Override
  public boolean isDisabledInternal() {
    return !wahlSelect.isSelected() && !wahlterminSelect.isSelected();
  }

  @Override
  public String getTargetViewId() {
    return DokumentVorlageSearchView.VIEW_ID;
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return Arrays.asList(DokumentVorlageCreateView.VIEW_ID, DokumentVorlageArchiveCreateView.VIEW_ID);
  }

  @Override
  protected String getLabel() {
    return getMessage(getLabelKey(), getMeta().getMehrzahlMessage());
  }

  @Override
  public String getLabelKey() {
    return "entity.manage.menu.item.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconDocument();
  }
}
